FUNCTION mrate_ratio_sigma, irate

;	22-Mar-2007   /gm
;	10-Apr-2007	error calculation modified to accomodate background corrected rates and sigmas
;	23-Jun-2011   add corrections for rom box areas /gm

;	calculates statistical errors on the ratios of spectral points


	common intensity_ratios
	common rate_averages
	common mbox_factors
 	common current_packet_time
	common output_items
	common spacecraft

	if( ratio_indices(irate) eq 0.) then return, 0.
	
	if( mrate_average(irate) eq 0.) then return, 0.
	
	if( mrate_average(ratio_indices(irate)) eq 0. ) then return, 0.

	if( (type_out lt 2) and (current_mjd ge rom_corr_mjd(spacecraft_id)) ) then begin
		return, (mrate_average(irate)*rom_corr(spacecraft_id,irate)/(mrate_average( ratio_indices(irate))*rom_corr(spacecraft_id,ratio_indices(irate))))* $
	  	sqrt((mrate_sigma(irate)/mrate_average(irate))^2 + (mrate_sigma(ratio_indices(irate))/mrate_average(ratio_indices(irate)))^2 )  ; don't need corrections in sqrt ratios since they apply to both numerator and denominator, and so cancel out
	endif else begin
		return, (mrate_average(irate)/mrate_average( ratio_indices(irate)))* $
	  	sqrt((mrate_sigma(irate)/mrate_average(irate))^2 + (mrate_sigma(ratio_indices(irate))/mrate_average(ratio_indices(irate)))^2 )
	endelse
	  
	end

