PRO sit_packet_counter_individual, filename
;+
; 	routine to list packets present for each minute of a day

; ****************************************************************

	packet_type = [576, 577, 605, 606, 607, 608, 609, 610, 611, 612, 613, 614, 615, 616, 617, 624]
	packet_present=intarr(16)


;	filename = '/data/joey/masongm1/Data/STEREO_data/sit_ahead/sit_ahead_2007_273_1_03.ptp'
;	filename = '/data/joey/masongm1/Data/STEREO_data/sit_behind/sit_behind_2007_240_1_04.fin'
;	filename = '/data/joey/masongm1/Data/Data_L1_flight/STEREO/sit_behind/sit_behind_2009_183_1_05.fin'
;	filename = '/data/joey/masongm1/Data/Data_L1_flight/STEREO/sit_ahead/sit_ahead_2013_060_1_04.ptp'

	openr, lun_input, filename, /get_lun

	count_reads=0L	
	packet = 0


newrec: 	read_stereo_pkt, lun_input, packet
	if n_elements(packet) eq 0 then goto, finish

;
;	compute current time
;
	current_time = tai2utc(double(packet.pkt.seconds), /NOCORRECT)
	current_mjd = double(current_time.mjd) + double(current_time.time)/double(86400.*1000)
	current_day = MJD2MODAYRHRMN(current_mjd)

;	process this packet

	apid = parse_stereo_pkt(packet, /APID )
	
	for i = 0,15  do if( apid eq packet_type(i) ) then packet_present(i)  = packet_type(i)

	if( apid eq 624 ) then begin
		print, current_day, packet_present, format="(25i5)"
		packet_present[*] = 0
	endif
	goto, newrec



;	if(count_reads gt 100) then break



	
finish:	
		close, /all     ; close all the files	

		print, " sit_packet_counter is finished"

end 
